// Armt.h : main header file for the ARMT application
//

#if !defined(AFX_ARMT_H__9AD3A7E5_3B67_11D3_B7C7_0004ACBD4F4C__INCLUDED_)
#define AFX_ARMT_H__9AD3A7E5_3B67_11D3_B7C7_0004ACBD4F4C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#define GetApp()	((CArmtApp *)AfxGetApp())
#define WM_TRAY		(WM_USER+1)


#include <afxtempl.h>
#include "ArmtDlg.h"


/////////////////////////////////////////////////////////////////////////////
//  
//
#define D_NO_DELETE_	1	//    
#define D_NO_INSERT_	1	//    SQL-
//#define D_FROMFILE_		"c:\\in.txt"	//    

/////////////////////////////////////////////////////////////////////////////
//  
//
#define MAXITEMSTR	255
#define MAXTLGSIZE	32000
#define IDT_TIMER1	1				//  
#define IDT_TIMER1_ELAPSE	60000u	//  1 
#define IDT_TIMER2	2				//  
#define IDT_TIMER2_ELAPSE	5000u	//  5 


#define DIV_OK	1
#define DIV_NO	2
#define DIV_ERR	3


/////////////////////////////////////////////////////////////////////////////
//   
// 
#define PROFILE_SECTION		"AlphaTelex"
// 
#define PARAM_NCHANNELS		"nChannels"
#define PARAM_PORTNAME		"PortName"
#define PARAM_CHTIMEOUT		"ChTimeout"
#define PARAM_ATEXT			"AutoText"
//  
#define PARAM_DB_SERVER		"db_server"
#define	PARAM_DB_BASE		"db_base"
#define PARAM_DB_USER		"db_user"
#define PARAM_DB_PASS		"db_passwd"
//  
#define PARAM_COM_SOUNDALL	"com_soundall"
#define PARAM_COM_ASK999	"com_ask999"
#define PARAM_COM_LOGFILE	"com_logfile"
#define PARAM_COM_DIVIDE	"com_divide"
#define PARAM_COM_TRASH		"com_trash"

/////////////////////////////////////////////////////////////////////////////
//   
//
struct Params {
	//   
	int nChanels;
	CStringArray PortName;
	CWordArray ChTimeout;
	CStringArray AutoText;
	//    
	CString db_server;
	CString db_base;
	CString db_user;
	CString db_passwd;
	//  
	BOOL com_soundall;
	BOOL com_ask999;
	CString com_logfile;
	BOOL com_divide;
	UINT com_trash;
};




/////////////////////////////////////////////////////////////////////////////
// CArmtApp:
// See Armt.cpp for the implementation of this ChTimeout
//

class CArmtApp : public CWinApp
{
public:
	CStringArray& GetTlgCountArray(CString buf,CStringArray &arr,CWordArray &iarr);
	CString GetTlgNumber(CString tlgtext);
	CArmtDlg * m_pDlg;
	void Lcs();
	void Ecs();
	BOOL Ecst();
	CRITICAL_SECTION crs;
	void ClearParam();
	void WriteParam();
	void ReadParam();
	Params m_param;
	CArmtApp();

// Overrides
	// ChTimeoutWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CArmtApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CArmtApp)
		// NOTE - the ChTimeoutWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ARMT_H__9AD3A7E5_3B67_11D3_B7C7_0004ACBD4F4C__INCLUDED_)
