// ArmtDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Armt.h"
#include "ArmtDlg.h"
#include "ConfigTlg.h"
#include "ConfigDb.h"
#include "ConfigCom.h"
#include "Telex.h"
#include "Ask999.h"
#include "Invalid.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArmtDlg dialog

CArmtDlg::CArmtDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArmtDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CArmtDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CArmtDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CArmtDlg)
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CArmtDlg, CDialog)
	//{{AFX_MSG_MAP(CArmtDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_RESTORE, OnRestore)
	ON_COMMAND(ID_CONFIGDB, OnConfigdb)
	ON_COMMAND(ID_CONFIGTLG, OnConfigtlg)
	ON_BN_CLICKED(IDC_CONFIGCOM, OnConfigcom)
	ON_BN_CLICKED(IDC_CLEARLOG, OnClearlog)
	ON_BN_CLICKED(IDC_CONFIGDB, OnConfigdb)
	ON_BN_CLICKED(IDC_CONFIGTLG, OnConfigtlg)
	ON_COMMAND(ID_CONFIGCOM, OnConfigcom)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArmtDlg message handlers

BOOL CArmtDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	CString title; title.LoadString(IDS_TITLE);
	SetWindowText(title);
	
	// TODO: Add extra initialization here
	m_list.AddColumn("  ");
	m_list.AddColumn("    . ");
	m_list.AddColumn("     .   ");
	m_list.AddColumn("                       "
		"                                                   "
		"                                                   ");
	SetActiveWindow();

	//     
	GetApp()->m_pDlg=this;
	StartAllThreads();

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CArmtDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CArmtDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CArmtDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CArmtDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch (message) {
	case WM_SIZE:
		{
			if (wParam==SIZE_MINIMIZED) Hide();
			else Show();
		}
		break;
	case WM_TRAY:
		{
			switch (lParam) {
			case WM_LBUTTONDBLCLK: Show(); break;
			case WM_RBUTTONDOWN:
				{
					CMenu menu;
					menu.LoadMenu(IDR_POPUP);

					CMenu* pPopup = menu.GetSubMenu(0);
					ASSERT(pPopup != NULL);

					APPBARDATA abd;
					abd.cbSize=sizeof(abd);
					abd.hWnd=NULL;
					SHAppBarMessage(ABM_GETTASKBARPOS,&abd);
					CPoint p(abd.rc.right,abd.rc.top);

					pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,
						p.x,p.y,this); // use main window for cmds
				}
				break;
			}
		}
		break;

	}
	
	return CDialog::DefWindowProc(message, wParam, lParam);
}

void CArmtDlg::ManageTaskbarIcon(UINT cmd, UINT iconID, UINT nID, LPCSTR str)
{
	NOTIFYICONDATA tnid; 
	HICON hicon=AfxGetApp()->LoadIcon(iconID);
 
	tnid.cbSize=sizeof(NOTIFYICONDATA); 
	tnid.hWnd=m_hWnd; 
	tnid.uID=nID;
	tnid.uFlags=NIF_MESSAGE|NIF_ICON|NIF_TIP; 
	tnid.uCallbackMessage=WM_TRAY; 
	tnid.hIcon=hicon;
	if (str) lstrcpyn(tnid.szTip,str,sizeof(tnid.szTip));
	else tnid.szTip[0]=0; 
 
	Shell_NotifyIcon(cmd, &tnid);
	if (hicon) DestroyIcon(hicon);
}

void CArmtDlg::OnOK() 
{
	// TODO: Add extra validation here
	Hide();
}

void CArmtDlg::Hide()
{
	CString cs; cs.LoadString(IDS_TITLE);
	SendMessage(WM_SYSCOMMAND,SC_MINIMIZE,0);
	ManageTaskbarIcon(NIM_ADD,IDR_MAINFRAME,0,cs);
	ShowWindow(SW_HIDE);
}

void CArmtDlg::Show()
{
	CString cs; cs.LoadString(IDS_TITLE);
	ManageTaskbarIcon(NIM_DELETE,IDR_MAINFRAME,0,cs);
	SendMessage(WM_SYSCOMMAND,SC_RESTORE,0);
	SetActiveWindow();
}

void CArmtDlg::OnExit() 
{
	// TODO: Add your command handler code here
	Exit();
}

void CArmtDlg::OnRestore() 
{
	// TODO: Add your command handler code here
	Show();
}

void CArmtDlg::Exit()
{
	if (MessageBox("   -  ?",
		" ",MB_ICONQUESTION|MB_OKCANCEL)==IDOK)	{
		//     tray-
		if (!GetApp()->Ecst()) {
			MessageBox("   -   !\n"
				"       \n",
				" ",MB_ICONINFORMATION|MB_OK);
		} else {
			ManageTaskbarIcon(NIM_DELETE,IDR_MAINFRAME,0,NULL);
			EndDialog(IDCANCEL);
			GetApp()->Lcs();
		}
	}
}

void CArmtDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	Exit();
}

void CArmtDlg::ConfigTlg()
{
	CConfigTlg dlg;
	dlg.DoModal();
}

void CArmtDlg::ConfigDb()
{
	CConfigDb dlg;
	dlg.m_server=GetApp()->m_param.db_server;
	dlg.m_base=GetApp()->m_param.db_base;
	dlg.m_user=GetApp()->m_param.db_user;
	dlg.m_pass=GetApp()->m_param.db_passwd;
	if (dlg.DoModal()==IDOK) {
		GetApp()->m_param.db_server=dlg.m_server;
		GetApp()->m_param.db_base=dlg.m_base;
		GetApp()->m_param.db_user=dlg.m_user;
		GetApp()->m_param.db_passwd=dlg.m_pass;
		GetApp()->WriteParam();
	}
}

void CArmtDlg::OnConfigdb() 
{
	// TODO: Add your command handler code here
	if (!GetApp()->Ecst())
		MessageBox("     !\n"
			"       \n",
			" ",MB_ICONINFORMATION|MB_OK);
	else {
		ConfigDb();
		GetApp()->Lcs();
	}
}

void CArmtDlg::OnConfigtlg() 
{
	// TODO: Add your command handler code here
	if (!GetApp()->Ecst())
		MessageBox("     !\n"
			"       \n",
			" ",MB_ICONINFORMATION|MB_OK);
	else {
		ConfigTlg();
		GetApp()->Lcs();
	}
}

void CArmtDlg::OnConfigcom() 
{
	// TODO: Add your control notification handler code here
	if (!GetApp()->Ecst())
		MessageBox("     !\n",
			"       \n"
			" ",MB_ICONINFORMATION|MB_OK);
	else {
		ConfigCom();
		GetApp()->Lcs();
	}
}

void CArmtDlg::ConfigCom()
{
	CConfigCom dlg;
	dlg.m_soundall=GetApp()->m_param.com_soundall;
	dlg.m_ask999=GetApp()->m_param.com_ask999;
	dlg.m_logfile=GetApp()->m_param.com_logfile;
	dlg.m_divide=GetApp()->m_param.com_divide;
	dlg.m_trash=GetApp()->m_param.com_trash;
	if (dlg.DoModal()==IDOK) {
		GetApp()->m_param.com_soundall=dlg.m_soundall;
		GetApp()->m_param.com_ask999=dlg.m_ask999;
		GetApp()->m_param.com_logfile=dlg.m_logfile;
		GetApp()->m_param.com_divide=dlg.m_divide;
		GetApp()->m_param.com_trash=dlg.m_trash;
		GetApp()->WriteParam();
	}
}

void CArmtDlg::OnClearlog() 
{
	// TODO: Add your control notification handler code here
	if (!GetApp()->Ecst())
		MessageBox("   -   !\n"
			"       \n",
			" ",MB_ICONINFORMATION|MB_OK);
	else {
		m_list.DeleteAllItems();
		GetApp()->Lcs();
	}
}


//     
static UINT BeepService(void *)
{
	int i;
	for (i=100; i<3000; i+=200) Beep(i,2);
	for (i=3000; i>100; i-=200) Beep(i,2);
	AfxEndThread(0);
	return 0;
}

//     
static UINT BeepServiceAsk(void *)
{
	int i;
	for (i=3000; i<5000; i+=100) Beep(i,2);
	for (i=5000; i>3000; i-=100) Beep(i,2);
	AfxEndThread(0);
	return 0;
}

BOOL CArmtDlg::AddToListOrLog(int channel, COleDateTime dt, CString tlgno, CString text,BOOL printlog)
{
	char tmp[MAXITEMSTR+1];
	BOOL toSQL=TRUE;
	BOOL retv=TRUE;

	//   ''
	if ((UINT)text.GetLength()<=GetApp()->m_param.com_trash) goto fin;

	// ,    
	if (GetApp()->m_param.com_ask999) {
		if (tlgno=="999999") {
			AfxBeginThread(BeepServiceAsk,NULL,THREAD_PRIORITY_LOWEST);
			CAsk999 dlg;
			dlg.m_tlgno=tlgno;
			dlg.m_text=text;
			if (dlg.DoModal()==IDOK) tlgno=dlg.m_tlgno;
			else toSQL=FALSE;
		}
	}

	GetApp()->Ecs();

	if (GetApp()->m_param.com_soundall) 
		AfxBeginThread(BeepService,NULL,THREAD_PRIORITY_LOWEST);

	//    200,   
	if (m_list.GetNumItems()>200) m_list.DeleteItem(0); 

	//  ,  
	if (printlog) {
		if (!LogTlgToFile(text,dt,channel)) {
			retv=FALSE; goto fin;
		}
	}

	//     
	//  
	sprintf(tmp," %02d ",channel);
	m_list.AddItem(0,tmp);
	//    
	m_list.AddItem(1,dt.Format("%d %b %Y %H:%M"));
	//  
	m_list.AddItem(2,tlgno);
	//  
	m_list.AddItem(3,text.Left(255));

	//  ,   
	m_list.SelectItem(m_list.GetNumItems()-1);
	m_list.EnsureVisible(m_list.GetNumItems()-1,TRUE);

	//      

fin:
	//   , ..  
	GetApp()->Lcs();
	return retv;
}


//    
static UINT AlphaService(void *tp)
{
	BYTE *buf=new BYTE[MAXTLGSIZE+1];
	CArmtDlg &pdlg=*GetApp()->m_pDlg;
	CString tlg_no;

	GetApp()->Ecs();
	DWORD channel=(DWORD)tp;
	CString port=GetApp()->m_param.PortName[channel];
	GetApp()->Lcs();

	CTelex t;
	if (!t.Connect(port)) {
		Beep(3000,100);
		AfxMessageBox("      '"+port+"'\n"
			"    !",
			MB_ICONEXCLAMATION|MB_OK);
		goto fin;
	} else {
		t.m_at.WriteByte('\x81'); Sleep(1000);
		if (t.m_at.buflen<1) {
			Beep(3000,100);
			AfxMessageBox("      '"+port+"'\n"
				"    !",
				MB_ICONEXCLAMATION|MB_OK);
			goto fin;
		} else {
			t.m_at.ClearBuffer();
		}
	}

	//         
	//    ,   .
	{
		WORD a=256;
		t.Lock();		//   ReceivLock  IBM_Read

		WORD da=0;
		do {
			CString tlgtext="";
			BYTE err;
			COleDateTime time;
			
			da=t.GetQueueElement(a,buf);
			if (da && t.ConvertRecieved((LPCSTR)buf,tlgtext,&err,&time)) {

#if defined(D_FROMFILE_)
				{
					CFile ff;
					if (ff.Open(D_FROMFILE_,CFile::modeRead|CFile::typeBinary|CFile::shareDenyNone)) {
						char *pbuf=tlgtext.GetBuffer(MAXTLGSIZE);
						int len=ff.Read(pbuf,MAXTLGSIZE);
						pbuf[len]=0;
						tlgtext.ReleaseBuffer(len+1);
						tlgtext.OemToAnsi();
						len=tlgtext.GetLength();
					} else {
						AfxMessageBox("    !");
						exit(255);
					}
				}
				
#endif

				//    ,    
				switch (pdlg.DivideTlgText(tlgtext,time,channel)) {
				case DIV_OK:
					if (!pdlg.LogTlgToFile(tlgtext,time,channel)) goto fin; 
					break;
				case DIV_NO:
					tlg_no=GetApp()->GetTlgNumber(tlgtext);
					if (!pdlg.AddToListOrLog(channel,time,tlg_no,tlgtext,TRUE)) goto fin;
					break;
				case DIV_ERR: 
					goto fin; 
				}

				//        
#if !defined(D_NO_DELETE_)
				t.DeleteQueueElement(a);
#endif
			} else {
				//  ,   
#if !defined(D_NO_DELETE_)
				t.DeleteQueueElement(a);
#endif
			}
			a+=da;
		} while (da && (buf[0] || buf[1]));

		//   
		COleDateTime rtime; 
		rtime.GetCurrentTime();
		t.SendTlg("000000","\n"+GetApp()->m_param.AutoText[channel]+
			rtime.Format("    %d %b %Y   %H:%M\n"));

		t.UnLock();		//   ReceivLock  IBM_Read

		//   
		Sleep(GetApp()->m_param.ChTimeout[channel]*1000);
	}

	//      
	for (;;) {

		WORD a=256;
		t.Lock();		//   ReceivLock  IBM_Read

		WORD da=0;
		do {
			CString tlgtext="";
			BYTE err;
			COleDateTime time;
			
			da=t.GetQueueElement(a,buf);
			if (da && t.ConvertRecieved((LPCSTR)buf,tlgtext,&err,&time)) {

				//    ,    
				switch (pdlg.DivideTlgText(tlgtext,time,channel)) {
				case DIV_OK:
					if (!pdlg.LogTlgToFile(tlgtext,time,channel)) goto fin; 
					break;
				case DIV_NO:
					tlg_no=GetApp()->GetTlgNumber(tlgtext);
					if (!pdlg.AddToListOrLog(channel,time,tlg_no,tlgtext,TRUE)) goto fin;
					break;
				case DIV_ERR:
					goto fin; 
				}

				//        
#if !defined(D_NO_DELETE_)
				t.DeleteQueueElement(a);
#endif
			}
			a+=da;
		} while (da && (buf[0] || buf[1]));
		t.UnLock();		//   ReceivLock  IBM_Read

		//   
		Sleep(GetApp()->m_param.ChTimeout[channel]*1000);
	}

fin:
	delete buf;
	t.UnLock();		//   ReceivLock  IBM_Read
	AfxEndThread(0);
	return 0;
}

void CArmtDlg::StartAllThreads()
{

	for (int i=0; i<GetApp()->m_param.nChanels; i++) {
		AfxBeginThread(AlphaService,(void *)i,THREAD_PRIORITY_BELOW_NORMAL);
	}
}

//        
int CArmtDlg::DivideTlgText(CString tlgtext, COleDateTime time,int channel)
{
	CStringArray ta;
	CString cs,tmp;
	int i,j,retv=DIV_NO;
	BOOL izvrat=FALSE;

	tmp=tlgtext;
	if (GetApp()->m_param.com_divide) {
nextmsg:
		izvrat=FALSE;
		//   
		i=tmp.Find("CCCC");					// 
		if (i==-1) i=tmp.Find("");		// -
		if (i==-1) i=tmp.Find("");		// -
		if (i==-1) i=tmp.Find("\r\n\r\n\r\n\r\n\r\n\r\n");
		if (i==-1) i=0;
		if (i>(int)GetApp()->m_param.com_trash) i=0;
		//     CCCC-FFFF
		//    
		j=tmp.Find("FFFF",i);				// 
		if (j==-1) j=tmp.Find("");		// -
		if (j==-1) {
			//    ,  
			//     
			izvrat=TRUE;
			if (tmp.GetLength()<=i+4) goto fin;
			j=tmp.Mid(i+4).Find("CCCC");	// 
			if (j>=0) { j+=i+4; goto maxho;}
			j=tmp.Mid(i+4).Find("");	// 
			if (j>=0) { j+=i+4; goto maxho;}
			j=tmp.Mid(i+4).Find("");	// 
			if (j>=0) { j+=i+4; goto maxho;}
			j=tmp.Mid(i+4).Find("\r\n\r\n\r\n\r\n\r\n\r\n");
			if (j>=0) { j+=i+4; goto maxho;}
		}
maxho:
		if (j==-1) j=tmp.GetLength();
		if (j<=i) goto fin;

		//    ,  
		ta.Add(tmp.Mid(i,j-i+4));

		//  ,    
		if (tmp.GetLength()>j+4) {
			tmp=tmp.Mid(j+(izvrat?0:4));
			goto nextmsg;
		} 

fin:
		//     
		if (ta.GetSize()>0) {
			CStringArray na;
			CWordArray ina;
			BOOL suc=TRUE;

			//     
			GetApp()->GetTlgCountArray(tlgtext,na,ina);	//  
			if (na.GetSize()>ta.GetSize()) suc=FALSE;
			else {
				int i,j;
				//   ,   ,
				//      
				for (i=0; i<ta.GetSize(); i++) {
					CString tnn=GetApp()->GetTlgNumber(ta[i]);
					for (j=0; j<na.GetSize(); j++) {
						if (na[j]==tnn) {
							ina[j]=1; break;
						}
					}
				}
				//   ,   ,
				//      
				for (i=0; i<na.GetSize(); i++) {
					for (j=0; j<ta.GetSize(); j++) {
						if (GetApp()->GetTlgNumber(ta[j])==na[i]) {
							ina[i]=1; break;
						}
					}
				}
					
				//    
				suc=TRUE;
				for (i=0; i<na.GetSize(); i++) suc*=ina[i];
			}
			
			// ,   
			if (!suc) {
				CInvalid dlg;
				dlg.m_text=tlgtext;
				dlg.DoModal();
			}

			//    (  )
			for (i=0; i<ta.GetSize(); i++) {
				CString tlgno=GetApp()->GetTlgNumber(ta[i]);
				if (!AddToListOrLog(channel,time,tlgno,ta[i],FALSE)) {
					retv=DIV_ERR; goto fin;
				}
			}
			retv=DIV_OK;
		}
	}
	return retv;
}

BOOL CArmtDlg::LogTlgToFile(CString text, COleDateTime dt, int channel)
{
	FILE *h;
	BOOL retv=TRUE;

	h=fopen(GetApp()->m_param.com_logfile,"ab+");
	if (h) {
		CString txt866=text; txt866.AnsiToOem();
		CString dtime=dt.Format("%d %b %Y %H:%M"); dtime.AnsiToOem();
		fprintf(h,"\n============== CHANNEL %2d === TIME %s ====================\n",
			channel,dtime);
		fwrite((LPCSTR)txt866,txt866.GetLength(),1,h);
		fclose(h);
	} else {
		if (GetApp()->m_param.com_logfile.GetLength()>0) {
			Beep(3000,100);
			AfxMessageBox("   .\n"
				"    !",
				MB_ICONEXCLAMATION|MB_OK);
			retv=FALSE; goto fin;
		}
	}
fin:
	return retv;
}
